/*
 * @(#)$Id$
 *
 * Copyright (c)2000 Regents of the University of California
 *
 */


package precache.util.graph;

import java.util.Set;
import java.util.Map;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
/**
 *  The <code>AbstractGraphBuilder</code> description.
 *  @version $Revision$, $Date$
 *  @author Kristian Kvilekval
 */
public  class AbstractGraphBuilder implements GraphBuilder {

    /* Private/Public Variables */
    /** Each  node is mapped to a set of Adjacent nodes */
    /** And edge is represent by each  */
//     HashMap  adjacentNodes = new HashMap ();
    
    /** Each node may have a set of edges.  Edges are used
     *  only when the user explicitely creates them or 
     *  request them.  Otherwise this Map is empty 
     */
//     HashMap  edges;

    GraphRep rep;
    EdgeImpl e = new EdgeImpl (null, null);

    AbstractGraphBuilder () {
        rep = new AdjacencyListGraphRep();
    } 
    AbstractGraphBuilder (GraphRep rep) {
        this.rep = rep;
    }

    protected  Set getAdjacentSet (Object o) {
        return rep.getAdjacentNodes (o);
//         HashSet adj = (HashSet)adjacentNodes.get (o);
//         if (adj == null) {
//              adjacentNodes.put (o, adj = new HashSet ());
//         }
//         return adj;
    }

//     protected HashMap getEdgeset () {
//         if (edges == null) {
//             // Make the edges set from the adjacent nodes.
//             Iterator nodes = adjacentNodes.entrySet().iterator ();
//             while (nodes.hasNext()) {
//                 Map.Entry  adjedges = (Map.Entry)nodes.next();
//                 Object v1 = adjedges.getKey();
//                 Iterator adjs = ((Set)adjedges.getValue()).iterator ();
//                 while (adjs.hasNext()) {
//                     Object v2 = adjs.next();
//                     Edge e  = createEdge (v1, v2);
//                     if (!edges.containsKey (e))
//                         edges.put (e, e);
//                 }
//             }
//         }
//         return edges;
//     }


    /** GraphBuilder methods */
    public Edge createEdge (Object v1, Object v2) {
        return new EdgeImpl (v1, v2);
    }

    public void addVertex (Object o) {
//         if (!adjacentNodes.containsKey(o)) 
//             getAdjacentSet(o);
        rep.addNode (o);
    }
    public void remVertex (Object v1) {
        if (rep.isNode (v1)) {

            Set adj = rep.getAdjacentNodes (v1);
            Iterator ai = adj.iterator();
            while (ai.hasNext()) {
                Object v2 = ai.next();
                rep.remEdge (e.setVertices(v1, v2));
            }
            rep.remNode(v1);
        }
            
//         if (adjacentNodes.containsKey(v1)) {
//             HashSet adj = getAdjacentSet (v1);
//             Iterator ai = adj.iterator();
//             while (ai.hasNext()) {
//                 Object v2 = ai.next();
//                 getAdjacentSet(v2).remove (v1);
//                 if (edges != null) {
//                     edges.remove (createEdge (v1,v2));
//                 }
//             }
//             adjacentNodes.remove (v1);
//         }
    }
    public void addEdge (Object v1, Object v2 ) {
//             if (!rep.isNode(v1)) rep.addNode (v1);
//             if (!rep.isNode(v2)) rep.addNode (v2);
        
        rep.addEdge (createEdge (v1, v2));
//         HashSet a1 =   getAdjacentSet(v1);
//         HashSet a2 =   getAdjacentSet(v2);
//         if (!a1.contains(v2))a1.add (v2);
//         if (!a2.contains(v1))a2.add (v1);
//         if (edges != null) {
//             Edge e = createEdge (v1, v2);
//             if (!edges.containsKey(e))
//                 edges.put (e, e);
//         }
    }
    public void remEdge (Object v1, Object v2) {
        rep.remEdge (createEdge (v1, v2));
//         getAdjacentSet(v1).remove (v2);
//         getAdjacentSet(v2).remove (v1);
//         if (edges != null) {
//             edges.remove (createEdge (v1, v2));
//         }
    }

    public void addEdge (Edge e) {

        rep.addEdge (e);
//         getEdgeset().put (e, e);
//         addEdge (e.getVertexA(), e.getVertexB());
    }
    public void remEdge (Edge e) {
        rep.remEdge (e);
//         remEdge (e.getVertexA(), e.getVertexB());
//         if (edges!=null) edges.remove (e);
    }
    public void remEdges (Object o) {
        remVertex (o);
        addVertex (o);
    }
//     public Edge getEdge (Object v1, Object v2) {
//         Edge key = createEdge (v1, v2);
//         Edge val = null;
//         if (edges != null) {
//             val = (Edge)edges.get (key);
//         }
//         return (val==null)?key:val;
//     }

    /** Graph Methods */

//     public int      countVertices() {
//         return rep.countNodes();
// //         return adjacentNodes.size ();
//     }
    public Set getVertices() {
        return rep.getNodes();
//         return adjacentNodes.keySet();
    }        
//     public Object[] getVertices(Object[] a) {
// //         return adjacentNodes.keySet().toArray (a);
//     }
    public  Set   getAdjacentVertices( Object o ) {
        return rep.getAdjacentNodes (o);
    }

//     public int      countEdges() {
//          return rep.getEdges().size();
// //         return getEdgeset().size();
//     }
    public Set   getEdges() {
        return rep.getEdges();
//         return (Set)getEdgeset().values();
    }
    public Set   getEdges(Object o) {
        return rep.getAdjacentEdges (o);
    }

    public Graph getGraph() {
        return new GraphImpl (this);
    }

};
