/*
 * @(#)$Id$
 *
 * Copyright (c)2000 Regents of the University of California
 *
 */


package precache.util.graph;


import java.util.Iterator;
import java.util.LinkedList;
import java.util.ArrayList;
import java.util.HashSet;

/**
 *  The <code>DFSGraphVisitor</code> Visits a given graph in
 * DFS order with a piggybacked visitor.
 *  @version $Revision$, $Date$
 *  @author Kristian Kvilekval
 */
public class DFSGraphVisitor implements GraphVisitor {

    /* Private/Public Variables */
    Graph        graph;
    GraphVisitor visitor;
    HashSet visited = new HashSet ();
    /**
     *  The default constructo
     */
    public DFSGraphVisitor (Graph g, GraphVisitor v) {
        graph = g;
        visitor = v;
    }

    public void visit (Object o) {
        visited.add (o);
        Iterator adjl = graph.getAdjacentVertices(o).iterator();
        while (adjl.hasNext()) {
            Object adj = adjl.next();
            if (!visited.contains (adj)) {
                //System.out.println ("DFSVisit" + adj);
                visit (adj);
            }
        }
        visitor.visit (o);
    }

    public static ArrayList  ordering (Graph g, Object root) {
        final ArrayList nodes = new ArrayList();
        GraphVisitor vs = new AbstractGraphVisitor () {
                public void visit (Object v) {
                    nodes.add (v);
                }
            };
        new DFSGraphVisitor(g, vs).visit (root);
        return nodes;
    }
};
