/*
 * @(#)$Id$
 *
 * Copyright (c)2000 Regents of the University of California
 *
 */


package precache.util.graph;


/**
 *  The <code>DirectedEdgeImpl</code> description.
 *  @version $Revision$, $Date$
 *  @author Kristian Kvilekval
 */
public class DirectedEdgeImpl extends EdgeImpl
    implements DirectedEdge {

    /* Private/Public Variables */
    int direction = DirectedEdge.OUT;

    DirectedEdgeImpl(Object v1, Object v2) {
        super (v1,v2);
    }
    DirectedEdgeImpl(Object v1, Object v2, int d) {
        super (v1,v2);
        direction = d;
    }

    public Edge setVertices(Object v1, Object v2) {
        vA = v1; vB = v2;
        return this;
    }

    public int getDirection() { return direction; }

    public DirectedEdge swap() {
        direction = -direction;
        return this;
    }

    public Object getSource () {
        return  vA;
    }
    public Object getSink () {
        return  vB;
    }

    public int hashCode () { 
        return (vA.hashCode() << 16 | vB.hashCode());
    }
    public boolean equals (Object o) {
        if (o instanceof DirectedEdgeImpl) {
            EdgeImpl e = (EdgeImpl)o;
            return ((vA == e.vA && vB == e.vB));
        }
        return false;
    }
    
};
