/*
 * @(#)$Id$
 *
 * Copyright (c)2000 Regents of the University of California
 *
 */


package precache.util.graph;

import java.util.List;
import java.util.LinkedList;
import java.util.Iterator;


/**
 *  The <code>TopologicalVisitor</code> description.
 *  @version $Revision$, $Date$
 *  @author Kristian Kvilekval
 */
public class TopologicalVisitor implements GraphVisitor {

    /* Private/Public Variables */
    private DFSGraphVisitor dfs ;
    private DirectedGraph graph;

    /**
     *  The default constructor
     */
    public TopologicalVisitor (DirectedGraph g, GraphVisitor v) {
        graph = g;
        dfs = new DFSGraphVisitor (g, v);
    }


    public void visit () {
        Iterator roots = graph.getRoots().iterator();
        while (roots.hasNext())
            visit (roots.next());
    }

    public void visit (Object o) {
        dfs.visit (o);
    }


    public static List ordering(DirectedGraph g, Object o) {

        final LinkedList nodes = new LinkedList();
        GraphVisitor vs = new AbstractGraphVisitor () {
                public void visit (Object v) {
                    nodes.addFirst (v);
                }
            };
        new DFSGraphVisitor(g, vs).visit (o);

        return nodes;
    }

    public static List ordering(DirectedGraph g) {

        final LinkedList nodes = new LinkedList();

        GraphVisitor vs = new AbstractGraphVisitor () {
                public void visit (Object v) {
                    nodes.addFirst (v);
                }
            };
        Iterator roots = g.getRoots().iterator();
        DFSGraphVisitor dfs = new DFSGraphVisitor(g, vs);
        while (roots.hasNext())
            dfs.visit (roots.next());

        return nodes;
    }
};
